=== testsuite/interactive/lib-graph/Makefile ===
#MODULES=
MAIN_MODULE=graph_example
#ADD_COMPFLAGS=
LIBRARIES=graphics

include ../../makefiles/Makefile.one
include ../../makefiles/Makefile.common
