=== debian/changelog ===
ocaml (3.12.1-4+deb7u1) wheezy-security; urgency=high

  * Non-maintainer upload by the Wheezy LTS Team. 
  * CVE-2015-8869
    OCaml versions 4.02.3 and earlier have a runtime bug that, 
    on 64-bit platforms, causes sizes arguments to an internal 
    memmove call to be sign-extended from 32 to 64-bits before 
    being passed to the memmove function.
    This leads arguments between 2GiB and 4GiB to be interpreted 
    as larger than they are (specifically, a bit below 2^64), 
    causing a buffer overflow.
    Arguments between 4GiB and 6GiB are interpreted as 4GiB smaller 
    than they should be, causing a possible information leak.
 
 -- Thorsten Alteholz <debian@alteholz.de>  Wed, 11 May 2016 19:03:02 +0200

ocaml (3.12.1-4) unstable; urgency=low

  * Change the Debian-specific behaviour of -custom (Closes: #678577)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 26 Jun 2012 21:39:18 +0200

ocaml (3.12.1-3) unstable; urgency=low

  [ Hendrik Tews ]
  * Fixes in startup and install files of ocaml-mode:
    - symlink *el files into elc dir (Closes: #452340)
    - use debian-pkg-add-load-path-item in emacsen-startup and emacsen-install
      (Closes: 671559)
    - compile el files with site-file enabled
    - use debian-emacs-flavor in emacsen-startup (see #662163)

  [ Stéphane Glondu ]
  * Fix debian/watch so that refman is not reported as a new version
  * Add some explicit dependencies to avoid spurious Lintian warnings
    about broken symlinks
  * Remove duplicate upstream changelog

 -- Stéphane Glondu <glondu@debian.org>  Mon, 14 May 2012 07:52:40 +0200

ocaml (3.12.1-2) unstable; urgency=low

  * Fix compilation on kfreebsd-any: do not add -R$dir in X11 link options

 -- Stéphane Glondu <glondu@debian.org>  Tue, 01 Nov 2011 16:11:01 +0100

ocaml (3.12.1-1) unstable; urgency=low

  [ Stéphane Glondu ]
  * New upstream release (Closes: #634621)
  * ocamlopt/arm: add .type directive for code symbols (LP: #810402)

  [ Mehdi Dogguy ]
  * Make objinfo show force_link and ccobjs/ccopts when needed

  [ Jonathan Nieder ]
  * debian/control: add Breaks against versions of dh-ocaml that relied on
    the ocaml{dumpapprox,plugininfo,byteinfo} tools (Closes: #642935)

  [ Stefano Zacchiroli ]
  * remove myself from Uploaders

  [ Samuel Thibault ]
  * Add support for ENOTSUP (Closes: #646372)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 01 Nov 2011 13:53:49 +0100
