=== debian/watch ===
version=3
opts=uversionmangle=s/\+/~/ \
http://caml.inria.fr/pub/distrib/ocaml-([\d\.]+)/ocaml-([^-]+)\.tar\.gz
